<template>
  <div class="upload-file">
    <el-upload
      :action="uploadFileUrl + '?prePath=' + prePath"
      :before-upload="handleBeforeUpload"
      :file-list="fileList"
      :limit="fileNumber"
      :on-error="handleUploadError"
      :on-exceed="handleExceed"
      :on-success="handleUploadSuccess"
      :show-file-list="false"
      :headers="headers"
      class="upload-file-uploader"
      ref="upload"
      :disabled="pageInfoType == 'view'"
    >
      <!-- 上传按钮 -->
      <el-button size="mini" type="success" :disabled="pageInfoType == 'view'"
        >选取文件</el-button
      >

      <!-- 上传提示 -->
      <div class="el-upload__tip" slot="tip" v-if="showTip">
        请上传
        <template v-if="fileSize">
          大小不超过 <b style="color: #f56c6c">{{ fileSize }}MB</b>
        </template>
        <template v-if="fileType">
          格式为 <b style="color: #f56c6c">{{ fileType.join("/") }}</b>
        </template>
        的文件
      </div>
    </el-upload>

    <!-- 文件列表 -->
    <transition-group
      style="width: 80%"
      class="upload-file-list el-upload-list el-upload-list--text"
      name="el-fade-in-linear"
      tag="ul"
    >
      <li
        :key="file.uid"
        class="el-upload-list__item ele-upload-list__item-content"
        v-for="(file, index) in list"
      >
        <el-link
          :href="
            file.url[0].indexOf('https') == -1 ? baseUrl + file.url : file.url
          "
          :underline="false"
          target="_blank"
        >
          <span class="el-icon-document" style="font-size: 12px">
            {{ getFileName(file.name) }}
          </span>
        </el-link>
        <div class="ele-upload-list__item-content-action">
          <el-link
            :underline="false"
            style="font-size: 12px"
            @click="handleDelete(file.url, index)"
            type="danger"
            >删除</el-link
          >
        </div>
      </li>
    </transition-group>
  </div>
</template>

<script>
export default {
  props: {
    // 值
    value: [String, Object, Array],
    // 大小限制(MB)
    fileSize: {
      type: Number,
      default: 200,
    },
    fileNumber: {
      type: Number,
      default: 1,
    },
    // 文件类型, 例如['png', 'jpg', 'jpeg']
    // default: () => ["doc", "xls", "pdf", "xml"],
    fileType: {
      type: Array,
      default: null,
    },
    // 是否显示提示
    isShowTip: {
      type: Boolean,
      default: true,
    },
    //保存服务器路径前缀地址
    prePath: {
      type: String,
      default: "",
    },
    //默认文件名称
    fileName: {
      type: String,
      default: "",
    },
    pageInfoType: {
      type: String,
      default: "",
    },
  },
  data() {
    return {
      number: 0,
      baseUrl: process.env.VUE_APP_API_BASE_URL + "/",
      uploadFileUrl:
        process.env.VUE_APP_API_BASE_URL + "/attendance/file/commonupload",
      uploadList: [],
      headers: {},
      fileList: [],
    };
  },

  /* watch: {
    value: {
      handler(val) {
        console.log("value",this.value);
        if (val) {
          let temp = 1;
          // 首先将值转为数组
          const list = Array.isArray(val) ? val : this.value.split(',');
          // 然后将数组转为对象数组
          this.fileList = list.map(item => {
            item = { name: item.name, url: item.url};
            item.uid = item.uid || new Date().getTime() + temp++;
            return item;
          });
        } else {
          this.fileList = [];
          return [];
        }
      },
    }
  },*/
  computed: {
    // 是否显示提示
    showTip() {
      return this.isShowTip && (this.fileType || this.fileSize);
    },
    // 列表
    list() {
      let temp = 1;
      if (this.value) {
        // 首先将值转为数组
        const list = Array.isArray(this.value) ? this.value : [this.value];
        list &&
          list.forEach((v) => {
            v.url.indexOf("https") >= 0 ? (v.url = JSON.parse(v.url)) : v.url;
          });
        // 然后将数组转为对象数组
        this.fileList = list.map((item) => {
          item = {
            name: item.name,
            url:
              item.url.indexOf("[`\`") >= 0 ? JSON.parse(item.url) : item.url,
          };
          item.uid = item.uid || new Date().getTime() + temp++;
          return item;
        });

        return this.fileList;
      } else {
        this.fileList = [];
        return [];
      }
    },
  },
  methods: {
    // 上传前校检格式和大小
    handleBeforeUpload(file) {
      // 校检文件类型
      if (this.fileType) {
        let fileExtension = "";
        if (file.name.lastIndexOf(".") > -1) {
          fileExtension = file.name.slice(file.name.lastIndexOf(".") + 1);
        }
        const isTypeOk = this.fileType.some((type) => {
          if (file.type.indexOf(type) > -1) return true;
          if (fileExtension && fileExtension.indexOf(type) > -1) return true;
          return false;
        });
        if (!isTypeOk) {
          this.$message.error(
            `文件格式不正确, 请上传${this.fileType.join("/")}格式文件!`
          );
          return false;
        }
      }
      // 校检文件大小
      if (this.fileSize) {
        const isLt = file.size / 1024 / 1024 < this.fileSize;
        if (!isLt) {
          this.$message.error(`上传文件大小不能超过 ${this.fileSize} MB!`);
          return false;
        }
      }
      this.number++;
      return true;
    },
    // 文件个数超出
    handleExceed() {
      this.$message.error(`上传文件数量不能超过 ${this.fileNumber} 个!`);
    },
    // 上传失败
    handleUploadError(err) {
      this.$message.error("上传失败, 请重试");
    },
    // 上传成功回调
    handleUploadSuccess(res, file) {
      if (res.code === 1) {
        this.uploadList.push({ name: res.fileName, url: res.url });
        console.log("uploadList:", this.uploadList);
        if (this.uploadList.length === this.number) {
          this.fileList = this.fileList.concat(this.uploadList);
          this.uploadList = [];
          this.number = 0;
          this.$emit("input", this.fileList);
        }
      } else {
        this.$message.error(res.msg);
      }
      // this.$message.success("上传成功");
      // this.$emit("input", res.url);
      // this.fileName=res.fileName
      // this.$emit("getFileName", res.fileName);
    },
    // 删除文件
    handleDelete(url, index) {
      //todo 接口请求删除
      this.value = this.value.filter((item) => item.url != url);
      // this.fileList.splice(index, 1);
      this.$emit("input", this.value);
    },
    // 获取文件名称
    getFileName(name) {
      //console.log("name",name)
      if (name && name.lastIndexOf("/") > -1) {
        return name.slice(name.lastIndexOf("/") + 1).toLowerCase();
      } else {
        return name;
      }
    },
  },
  created() {
    //this.fileList = this.list;
  },
};
</script>

<style scoped lang="scss">
.upload-file-uploader {
  margin-bottom: 5px;
}
.upload-file-list .el-upload-list__item {
  border: 1px solid #e4e7ed;
  line-height: 2;
  margin-bottom: 10px;
  position: relative;
}
.upload-file-list .ele-upload-list__item-content {
  display: flex;
  justify-content: space-between;
  align-items: center;
  color: inherit;
}
.ele-upload-list__item-content-action .el-link {
  margin-right: 5px;
}
</style>
